Bug 1599242 - version of cryptocpp is out of date: SHA-3 hash gives incorrect value
Summary: version of cryptocpp is out of date: SHA-3 hash gives incorrect value
Keywords:
Status: ON_QA
Alias: None
Product: Fedora EPEL
Classification: Fedora
Component: cryptopp
Version: epel7
Hardware: Unspecified
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: nucleo
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2018-07-09 09:50 UTC by Bruce Adams
Modified: 2019-09-20 00:46 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug


Attachments (Terms of Use)

Description Bruce Adams 2018-07-09 09:50:15 UTC
Description of problem:

The version of libcrypto++ provided by EPEL for RHEL7 claims to implement the SHA-3 algorithm. However, it uses an out of date pre-release version which is not the algorithm standardised.
The algorithm seems to have been standardised in v5.6.4 whereas EPEL provides v5.6.2.
The fix should be to provide v5.6.4 or later instead.

Steps to reproduce:

This is easy to reproduce see https://stackoverflow.com/questions/51215190/incorrect-behaviour-generating-sha3-hash-with-cryptopp/51226825#51226825

Version-Release number of selected component (if applicable):

v5.6.2

Actual results:

An empty string gives the incorrect hash 
C5D2460186F7233C927E7DB2DCC703C0E500B653CA82273B7BFAD8045D85A470

Expected results:

An empty string should give the hash A7FFC6F8BF1ED76651C14756A061D662F580FF4DE43B49FA82D80A4B80F8434A

Additional info:

Comment 1 Nicolas Chauvet (kwizart) 2018-11-05 16:01:47 UTC
I'm pretty sure there is an ABI break with the update from 5.6.2->5.6.4/5
Can you check using the f27 branch ?

Comment 2 Fedora Update System 2019-09-19 12:51:05 UTC
FEDORA-EPEL-2019-209b03a8a4 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-209b03a8a4

Comment 3 Nicolas Chauvet (kwizart) 2019-09-19 13:15:05 UTC
Unfortunately, there is an ABI break with this version (as I said). But if breaking ABI, please at least ask for permission on epel sig.
But at this point it's questionable to keep a version that old. Best would to update to a modern version and rebuild dependencies.

Comment 4 Fedora Update System 2019-09-20 00:46:08 UTC
cryptopp-5.6.5-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2019-209b03a8a4


Note You need to log in before you can comment on or make changes to this bug.